;
;	>>> Beam Racer by JAC! <<<
;
;	Created 2011-04-01/2011-04-23 for Revision 2011 in Saarbrcken.
;
;	This is the test frame for the sound.

;	Set to 0 for NTSC version and to 1 for PAL vesion
pal	= 1;


	org $80
cnt		.ds 1
sound_zp	.ds 3	;3 bytes
volatile_zp	.ds 4

	icl "../VCS.asm"

;===============================================================

; Start of code
	opt h-f+l+
	org $f000

	icl "BeamRacer-Sound.asm"

start	sei
	cld
	ldx #$ff
	txs
	lda #$00
init	sta $00,x
	dex
	bne init

	.proc main_loop
	jsr upper_border
	jsr lower_border
	inc cnt
	jmp main_loop
	.endp

	.proc upper_border
	lda #$02
	sta $00
	sta wsync
	sta wsync
	lda #$2c
	sta tim64t
	sta wsync
	sta $00
	rts
	.endp

	.proc replay 
	lda swchb
	and #$01
	bne lf2a9
	lda cnt
	and #$03
	bne lf2a9
	inc pattern_hi

lf2a9	lda swchb
	and #$02
	bne lf2c4
	lda cnt
	and #$03
	bne lf2c4
	lda pattern_hi
	beq lf2c4
	dec pattern_hi
lf2c4
	lda swchb
	and #$08
	bne lf2d8

	lda #$00
	sta audv0
	sta audv1
	rts

lf2d8	jmp sound.player
	.endp

	.proc lower_border
	.if pal=0
	ldy #$39
	.else
	ldy #$39+12
	sta wsync
	sta wsync
	.endif
screen	sta wsync
	sta wsync
	sta wsync
	sta wsync
	sty colupf
	dey
	bne screen
	sta wsync
	sta wsync
	lda #$82
	sta vblank
	
	sta wsync
	lda #$21
	sta tim64t
	
	jsr replay
	
lf2e6	lda intim
	bne lf2e6
	sta wsync
	lda #$82
	sta vblank
	lda #$02
	sta vblank
	rts
	.endp


	org $fffc
	.word start, start

  
